// JavaScript Document
var isOver = false;
function init_FIBPassage() {
    jQuery.fn.limitMaxlength = function(options) {
        var settings = jQuery.extend({
            attribute : "maxlength",
            onLimit : function() {
            },
            onEdit : function() {
            }
        }, options);

        // Event handler to limit the textarea
        var onEdit = function() {
            var textarea = jQuery(this);
            var maxlength = parseInt(textarea.attr(settings.attribute));

            if (textarea.val().length > maxlength) {
                textarea.val(textarea.val().substr(0, maxlength));

                // Call the onlimit handler within the scope of the textarea
                //jQuery.proxy(settings.onLimit, this)();
            }

            // Call the onEdit handler within the scope of the textarea
            jQuery.proxy(settings.onEdit, this)(maxlength - textarea.val().length);
        };

        this.each(onEdit);

        // return this.keyup(onEdit).keydown(onEdit).focus(onEdit).live('input paste', onEdit);
        return this.keyup(onEdit).keydown(onEdit).focus(onEdit).bind('input paste', onEdit);
    };
    var onEditCallback = function(remaining) {
        $(this).siblings('.charsRemaining').text('Characters remaining: ' + remaining);
        /*if(remaining > 0){
         $(this).css('background-color', 'white');
         }
         //console.log("Characters remaining: " + remaining);*/
    };
    var onLimitCallback = function() {
        //$(this).css('background-color', 'red');
        //console.log("Limit Reached");
    };
    var storedActivityID;
    $('.textarea').each(function(index, element) {
        var activityID = getActivityID($(this).attr('id'));
        var typeinID = $(this).attr('id');
        var typeinName = $(this).attr('name');

        // ** Limiting the number of characters a user is allowed to enter
        //$(this).attr('maxlength', globalScope[activityID + '_maxChars']);
        var maxLength = globalScope[activityID + '_maxChars'];
        $(this).attr('maxlength', maxLength);

        $(this).limitMaxlength({
            onEdit : onEditCallback,
            onLimit : onLimitCallback
        });

        // ** If The user is not to be allowed to cut, copy & paste
        var enableCutCopyPaste = globalScope[activityID + '_enableCutCopyPaste'];
        if (!enableCutCopyPaste) {
            // $(this).live("cut copy paste", function(e) {
            $(this).bind("cut copy paste", function(e) {
                //$(this).bind("cut copy paste",function(e) {
                e.preventDefault();
            });
        }

        // ** Restricting the user input based on the defined restrictions
        var restrictInput = globalScope[activityID + '_restrict'];
        if (restrictInput.toLowerCase() != 'none') {
            var allowedChars = globalScope[activityID + '_allowChars'];
            var restrictedChars = globalScope[activityID + '_restrictChars'];
            var caseAllowed = globalScope[activityID + '_caseAllowed'].toLowerCase();
            //console.log('restrictInput = '+restrictInput+' : allowedChars = '+allowedChars+' : restrictedChars = '+restrictedChars+' : caseAllowed = '+caseAllowed);
            var o = {};
            var propertiesCount = 0;
            if (allowedChars != '') {
                o.allow = allowedChars;
                propertiesCount++;
            }
            if (restrictedChars != '') {
                o.ichars = restrictedChars;
                propertiesCount++;
            }
            if (caseAllowed != 'both') {
                o[caseAllowed] = true;
                propertiesCount++;
            }
            if (restrictInput == 'AlphaNumeric') {
                if (propertiesCount > 0) {
                    $(this).alphanumeric(o);
                } else {
                    $(this).alphanumeric();
                }
            }
            if (restrictInput == 'Alphabets') {
                if (propertiesCount > 0) {
                    $(this).alpha(o);
                } else {
                    $(this).alpha();
                }
            }
            if (restrictInput == 'Numeric') {
                if (propertiesCount > 0) {
                    $(this).numeric(o);
                } else {
                    $(this).numeric();
                }
            }
        }

        // ** Store the Default text of the input fields in a global variable
        /*if($(this).val() != ''){
        globalScope[typeinID + '_value'] = $(this).val();
        // ** Add focus in & out listeners only when there is a default value
        $(this).on('focusin', {activityID:activityID, typeinID:typeinID}, mouseEventHandler_FIBPassage);
        $(this).on('focusout', {activityID:activityID, typeinID:typeinID}, mouseEventHandler_FIBPassage);
        }*/

        // ** Add Event listeners
        $(this).on('keyup', {
            activityID : activityID,
            typeinID : typeinID
        }, mouseEventHandler_FIBPassage);
        // ** Add focus in & out listeners only when there is a default value
        $(this).on('focusin', {
            activityID : activityID,
            typeinID : typeinID
        }, mouseEventHandler_FIBPassage);
        $(this).on('focusout', {
            activityID : activityID,
            typeinID : typeinID
        }, mouseEventHandler_FIBPassage);
        // ** Disabling the submit button for each activity
        if (activityID != storedActivityID) {
            storedActivityID = activityID;

            // $('#' + activityID).find(':submit').on('click', {
            $('#' + activityID).find('a[id$="_submit"]').on('click', {
                activityID : activityID
            }, onSubmit_FIBPassage);
            //sortGroups(activityID);
        }
    });
}

function mouseEventHandler_FIBPassage(event) {
    var eventTarget = event.target;
    var eventType = event.type;
    var activityID = event.data.activityID;
    var typeinID = event.data.typeinID;
    var jqTypeIn = $('#' + typeinID);
    var text = jqTypeIn.val();
    var defaultText = globalScope[typeinID + '_value'];

    //console.log('eventType = '+eventType+' :: "'+text+'" :: "'+globalScope[typeinID + '_value']+'"');
    switch(eventType) {
        case "focusin" :
            /*if(text == defaultText){
             jqTypeIn.val('');
             }*/
            jqTypeIn.removeClass('fillin-focusout');
            jqTypeIn.addClass('fillin-focusin');
            break;
        case "focusout" :
            /*if(text == ''){
             jqTypeIn.val(defaultText);
             }*/
            jqTypeIn.removeClass('fillin-focusin');
            jqTypeIn.addClass('fillin-focusout');
            break;
        case "keyup" :
            updateSubmitButtonState_FIBPassage(typeinID);
            break;
    }
}

function updateSubmitButtonState_FIBPassage(typeinID) {
    var activityID = getActivityID(typeinID);
    var userAnswers = [];
    var totalFib_count = 0;
    $('#' + activityID).find('.textarea').each(function(index, element) {
        if ($(this).val() != '' && $(this).val() != globalScope[$(this).attr('id') + '_value']) {
            userAnswers.push($(this).val());
        }
        totalFib_count++;
    });

    //console.log("updateSubmitButtonState_FIBPassage() | User Answers = "+userAnswers+" : Length = "+userAnswers.length+" : Total FIB count = "+totalFib_count);
    var jqSubmitBtn = $('#' + activityID + '_submit');
    if (jqSubmitBtn.attr('id') != undefined) {
        if (userAnswers.length == totalFib_count && !isOver) {// ** Enable Submit button
            /*jqSubmitBtn.removeClass('button-images-submit-disabled');
             jqSubmitBtn.addClass('button-images-submit button');
             jqSubmitBtn.removeAttr('disabled');*/
            jqSubmitBtn.removeClass('simple-btn-disabled').addClass('simple-btn');
        } else {// ** Disable Submit button
            /*jqSubmitBtn.removeClass('button-images-submit button');
             jqSubmitBtn.addClass('button-images-submit-disabled');
             jqSubmitBtn.attr('disabled', 'disabled');*/
            jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
        }
    } else {
        alert('ERROR: Submit button with a matching Group / Activity ID not found. The ID needs to be: GroupID + "_submit".');
    };
}

function onSubmit_FIBPassage(event) {
    // alert('onSubmit_FIBPassage() | ' + event.data.activityID);
    var eventTarget = event.target;
    if ($(eventTarget).hasClass('simple-btn-disabled')) {
        return;
    }
    var activityID = event.data.activityID;

    // ** Increment the attempt count
    if (globalScope[activityID + '_attemptCount'] == undefined) {
        globalScope[activityID + '_attemptCount'] = 0;
    }
    globalScope[activityID + '_attemptCount'] += 1;

    // ** Get the User Answers
    var userAnswers = [];
    $('#' + activityID).find('.textarea').each(function() {
        userAnswers.push({
            id : $(this).attr('id'),
            value : $(this).val()
        });
    });
    // ** Get individual Activities validation data
    var correctAnswers = globalScope[activityID + '_correctAnswers'];
    var attemptCount = globalScope[activityID + '_attemptCount'];
    var noOfTries = globalScope[activityID + '_noOfTries'];
    var showTickCross = globalScope[activityID + '_showTickCross'];
    var caseSensitive = globalScope[activityID + '_caseSensitiveValidation'];
    var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();

    // ** Evaluate the User Answers
    var oEvulate = evaluate_FIBPassage(activityID, userAnswers, correctAnswers, caseSensitive, showTickCross);
    //console.log('User Correct Count = '+oEvulate.userCorrectCount+' : User Incorrect Count = '+oEvulate.userIncorrectCount);

    var feedbackID;
    var correct = false;

    if (oEvulate.fbType == 'correct') {
        // ** All Correct
        //console.log('Correct');
        correct = true;
        feedbackID = getFeedbackID_FIBPassage('correct', activityID);
    } else {
        // ** Incorrect
        if (oEvulate.userCorrectCount > 0 && feedbackType == "correctincorrectpartial") {
            // ** Partially Correct Feedback
            //console.log('Partially Correct');
            feedbackID = getFeedbackID_FIBPassage('partial', activityID);
        } else {
            // ** ALL Incorrect Feedback
            //console.log('Incorrect');
            feedbackID = getFeedbackID_FIBPassage('incorrect', activityID);
        }
    }

    ///showFeedback(feedbackID, popupARIA);
    // console.log(feedbackID + ' : ' + popupARIA);
    showFeedback(feedbackID, popupARIA, window.document);

    if (attemptCount == noOfTries || correct) {
        // ** Disable Activity
        isOver = true;
        disableActivity_FIBPassage(activityID);
        //if(showTickCross){
        //	$('#' + activityID + '_tickcross').removeClass('hidden');
        //}
    }
}

function evaluate_FIBPassage(activityID, userAnswers, correctAnswers, caseSensitive, showTickCross) {
    var userCorrectCount = 0;
    var userIncorrectCount = 0;
    for (var i = 0; i < userAnswers.length; i++) {
        var typeInID = userAnswers[i].id;
        var userAnswerVal = userAnswers[i].value;
        var fibNo = typeInID.substring(typeInID.lastIndexOf('_') + 1, typeInID.length);
        var correctAnswer = correctAnswers[i];
        //console.log('userAnswers['+i+'] = '+userAnswerVal+' : correctAnswer['+i+'] = '+correctAnswer);
        var correct = isCorrect_FIBPassage(userAnswerVal, correctAnswer, caseSensitive);
        //console.log('Fib '+i+' | Correct = '+correct);
        (correct) ? userCorrectCount++ : userIncorrectCount++;

        // ** Add Tick and Cross if required
        if (showTickCross) {
            addTickOrCross_FIBPassage(activityID, fibNo, correct);
        }
    }
    if (userCorrectCount == userAnswers.length) {
        // ** All Correct
        return {
            fbType : 'correct',
            userCorrectCount : userCorrectCount,
            userIncorrectCount : userIncorrectCount
        };
    }
    if (userIncorrectCount == userAnswers.length) {
        // ** All Incorrect
        return {
            fbType : 'incorrect',
            userCorrectCount : userCorrectCount,
            userIncorrectCount : userIncorrectCount
        };
    }
    // ** Partially Correct
    return {
        fbType : 'partial',
        userCorrectCount : userCorrectCount,
        userIncorrectCount : userIncorrectCount
    };
    ;
}

function addTickOrCross_FIBPassage(activityID, fibNo, correct) {
    var indicatorID = 'indicator_' + fibNo;
    var jqTickCross = $('#' + activityID + '_tickcross img[id^="' + indicatorID + '"]');
    //console.log(indicatorID+' : Ind ID = '+jqTickCross.attr('id')+' : Parent ID = '+jqTickCross.parent().parent().attr('id'));
    if (correct) {
        jqTickCross.attr('src', 'images/fb_tick.png');
        jqTickCross.attr('alt', 'correct');
    } else {
        jqTickCross.attr('src', 'images/fb_cross.png');
        jqTickCross.attr('alt', 'incorrect');
    }
}

function isCorrect_FIBPassage(userAnswer, correctAnswer, caseSensitive) {
    var arr = correctAnswer.split('~');
    for (var j = 0; j < arr.length; j++) {
        //console.log('isCorrect_FIBPassage() | '+userAnswer+' :: '+arr[j]);
        if (caseSensitive) {
            if (userAnswer == arr[j]) {
                return true;
            }
        } else {
            if (userAnswer.toLowerCase() == arr[j].toLowerCase()) {
                return true;
            }
        }
    }
    return false;
}

function getFeedbackID_FIBPassage(evaluation, activityID) {
    //console.log('getFeedbackID_FIBPassage() | evaluation = '+evaluation+' : Activity ID = '+activityID);
    var feedbackID;
    var feedbackType = globalScope[activityID + '_feedbackType'].toLowerCase();
    var attemptCount = globalScope[activityID + '_attemptCount'];

    if (feedbackType == 'generic') {
        feedbackID = activityID + '_generic';
    } else if (feedbackType == 'correctincorrect' || feedbackType == 'correctincorrectpartial') {
        feedbackID = activityID + '_' + evaluation + '_' + attemptCount;
    } else {
        alert('ERROR: Feedback Type specified "' + feedbackType + '" is invalid. Valid feedback types are:\n1) Generic\n2) CorrectIncorrect\n3) CorrectIncorrectPartial');
    }

    return feedbackID;
}

function disableActivity_FIBPassage(activityID) {
    //console.log('disableActivity_FIBPassage() | Activity ID = '+activityID);
    var storedActivityID;
    $('#' + activityID).find('.textarea').each(function(index, element) {
        $(this).removeClass('button');
        $(this).attr('disabled', 'disabled');
        $(this).attr('readonly', 'readonly');
    });
    // var jqSubmitBtn = $('#' + activityID).find(':submit');
    var jqSubmitBtn = $('#' + activityID).find('a[id$="_submit"]');
    /*jqSubmitBtn.removeClass('button-images-submit button');
     jqSubmitBtn.addClass('button-images-submit-disabled');
     jqSubmitBtn.attr('disabled', 'disabled');*/
    jqSubmitBtn.removeClass('simple-btn').addClass('simple-btn-disabled');
}

/* START ---- Try for GROUP FIB's */
var myAnswers = [];
function sortGroups(activityID) {
    $('#' + activityID).find('.fillin').each(function(index, element) {
        //$(this).find('.fillin:input[name="'+typeinName+'"]').each(function(index, element) {
        var typeinName = $(this).attr('name');
        $('.fillin:input[name="' + typeinName + '"]').each(function(index, element) {
            var typeinID = $(this).attr('id');
            var correctAnswers = globalScope[activityID + '_correctAnswers'];
            var answerID = getAnswerID(typeinID);

            if (globalScope['answers_' + typeinName] == undefined) {
                globalScope['answers_' + typeinName] = [];
                myAnswers.push(globalScope['answers_' + typeinName]);
            }

            if (!has(globalScope['answers_' + typeinName], correctAnswers[answerID])) {
                //console.log('Pushing '+correctAnswers[answerID]+' in [answers_' + typeinName+']');
                globalScope['answers_' + typeinName].push(correctAnswers[answerID]);
            }

            //console.log(index+' :: '+name+' :: '+id+" :: "+correctAnswers[answerID]);
        });
    });
    traceArray(myAnswers);
}

function traceArray(arr, append) {
    for (var i = 0; i < arr.length; i++) {
        //console.log('Index '+i);
        for (var j = 0; j < arr[i].length; j++) {
            //console.log('\t'+arr[i][j]);
        }
    }
}

function has(arr, elem) {
    for (var i = 0; i < arr.length; i++) {
        if (arr[i] == elem) {
            return true;
        }
    }
    return false;
}

function getAnswerID(fibID) {
    return fibID.substring(fibID.lastIndexOf('_'), fibID.length);
}

function onClosePopup() {
}

/* END ---- Try for GROUP FIB's */